package de.htwberlin.magw;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageButton;
import de.htwberlin.magw.model.PatientInfo;

public class HomeActivity extends NfcPendingIntentActivity {

	private static final String LOG_TAG = "HomeActivity";
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.home);

		ImageButton patient = (ImageButton) findViewById(R.id.patient);
		final  Intent intent = new Intent(this, de.htwberlin.magw.VitaldatenActivity.class);
		patient.setOnClickListener(new View.OnClickListener() {
			public void onClick(View vitaldaten) {
				if (PatientInfo.getInstance().getUserId() != null) {
					startActivity(intent);
				} else {
					postMessage(getString(R.string.no_patient_info));
				}
			}
		});
/*		
		ImageButton calendar = (ImageButton) findViewById(R.id.calendar);
        patient.setOnClickListener(new View.OnClickListener() {
          public void onClick(View simple_calendar_view) {
          }
        });
        
        final  Intent intent2 = new Intent(this, de.htwberlin.magw.CalendarViewActivity.class);
         calendar.setOnClickListener(new View.OnClickListener() {
           public void onClick(View simple_calendar_view) {
             startActivity(intent2);
      }
       });
		
	*/	
	}
	
	private void postMessage(String message) {
		this.postToastMessage(message);
	}
}
