package de.htwberlin.magw;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;

public class MenuItemsAdapter extends BaseAdapter {
    private Context mContext;

    public MenuItemsAdapter(Context c) {
        mContext = c;
    }

    public int getCount() {
        return mThumbIds.length;
    }

    public Object getItem(int position) {
        return null;
    }

    public long getItemId(int position) {
        return 0;
    }

    // create a new ImageView for each item referenced by the Adapter
    public View getView(int position, View convertView, ViewGroup parent) {
        ImageView imageView;
        if (convertView == null) {  // if it's not recycled, initialize some attributes
            imageView = new ImageView(mContext);
            imageView.setLayoutParams(new GridView.LayoutParams(85, 85));
            imageView.setScaleType(ImageView.ScaleType.CENTER_CROP);
            imageView.setPadding(8, 8, 8, 8);
        } else {
            imageView = (ImageView) convertView;
        }

        imageView.setImageResource(mThumbIds[position]);
        return imageView;
    }

    // references to the icons/images
    private Integer[] mThumbIds = {
            R.drawable.ic_menu_library_blue, R.drawable.ic_menu_calendar_green,
            R.drawable.ic_menu_news_orange, R.drawable.ic_menu_patient_blue,
            R.drawable.ic_menu_admin_yellow,R.drawable.ic_menu_heart_red, 
            
    };

	
}