/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#include "controller.h"
#include <QVector>
#include <QTextStream>

Controller::Controller()
{
    QTextStream cout(stdout, QIODevice::WriteOnly);
    cout<<"erstelle NFCCommunicator"<<endl;
    _nfc = new NFCCommunicator();
    cout<<"erfolg!"<<endl;
    _nfcTimer = new QTimer();
    _nfcTimer->setInterval(2*1000); // alle 5 Sekunden
    connect(_nfcTimer, SIGNAL(timeout()), _nfc, SLOT(writeData()));
    _nfcTimer->start();
}
