//
//  AnmeldungViewController.m
//  NFCKrankehausAnmeldung
//
//  Created by Maurus Rohrer on 1/18/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "AnmeldungViewController.h"
#import "SBJson.h"

@implementation AnmeldungViewController
@synthesize name,vorname,strasse,stadt,geburtstag,telnummer,plz,geschlecht,tabView,blutgruppe,password,error,knView,krankNumber,allergie1,allergie2,allergie3,allergie4,allergie5,allergie6,allergie7,allergie8;
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Initialization code here.
    }
       return self;
}

- (void)dealloc
{
    [super dealloc];
}

-(void)initAfterload:(LibnfcDeviceManager*)device{
    [geschlecht selectItemAtIndex:0];
    [blutgruppe selectItemAtIndex:0];
    [tabView setHidden:true];
    libnfcDevice = device;
}

- (IBAction)loadPatienInfo:(id)sender{
 
    // Prepare URL request to download statuses from Twitter
    NSMutableString *urlToGo = [[NSMutableString alloc] initWithString:@"http://mgt.inka.f4.htw-berlin.de:5000/personen/"];
    [urlToGo appendString:[krankNumber stringValue]];
    NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:urlToGo]];
    
    // Perform request and get JSON back as a NSData object
    NSData *response = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:nil];
    
    // Get JSON as a NSString from NSData response
    NSString *jsonString = [[NSString alloc] initWithData:response encoding:NSUTF8StringEncoding];
    NSLog(@"url antwort %@", jsonString);
    NSString *testString = [jsonString stringByReplacingOccurrencesOfString:@"\\\"" withString:@"\""];
    testString = [testString substringWithRange:NSMakeRange(1, [testString length] - 2)];
    NSLog(@"bessere antwort %@", testString);
    SBJsonParser *jsonParser = [[SBJsonParser alloc] init];
    NSError *errors = nil;
   // NSArray *jsonObjects = [jsonParser objectWithString:jsonString error:&error];

    
    
    id jsonObject = [jsonParser objectWithString:jsonString error:&errors];
    [jsonParser release], jsonParser = nil;
    if ([jsonObject isKindOfClass:[NSDictionary class]]){
        //patient existiert
        patientNeu=false;
         // treat as a dictionary, or reassign to a dictionary ivar
        NSLog(@"ha jason hat NSDictionary");
        //fill parameters
        if ([jsonObject objectForKey:@"ort"]!=[NSNull null]) {
            NSLog(@"ha jetzt leerer ort %@",[jsonObject objectForKey:@"ort"]);
            [stadt setStringValue:[jsonObject objectForKey:@"ort"]];
        }
        if ([jsonObject objectForKey:@"adresse"]!=[NSNull null]) {
            
            [strasse setStringValue:[jsonObject objectForKey:@"adresse"]];
        }
        if ([jsonObject objectForKey:@"plz"]!=[NSNull null]) {
            
            [plz setStringValue:[jsonObject objectForKey:@"plz"]];
        }
        if ([jsonObject objectForKey:@"nachname"]!=[NSNull null]) {
            
            [name setStringValue:[jsonObject objectForKey:@"nachname"]];
        }
        if ([jsonObject objectForKey:@"vorname"]!=[NSNull null]) {
            
            [vorname setStringValue:[jsonObject objectForKey:@"vorname"]];
        }
        if ([jsonObject objectForKey:@"notfallnummer"]!=[NSNull null]) {
            
            [telnummer setStringValue:[jsonObject objectForKey:@"notfallnummer"]];
        }
        if ([jsonObject objectForKey:@"geschlecht"]!=[NSNull null]) {
            if ([[jsonObject objectForKey:@"geschlecht"] isEqualToString:@"weiblich"]) {
                [geschlecht selectItemAtIndex:0];
            }else{
                [geschlecht selectItemAtIndex:1];  
            }
        }

        //Geburtstag!!!
        if([jsonObject objectForKey:@"geburtstag"]!=[NSNull null]){
            NSDateFormatter* df = [[NSDateFormatter alloc]init];
            [df setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
            NSDate* date = [df dateFromString:[jsonObject objectForKey:@"geburtstag"]];
            [geburtstag setDateValue:date];
        }

        if ([jsonObject objectForKey:@"blutgruppe"]!=[NSNull null]) {
            //Blutgruppe
            if ([[jsonObject objectForKey:@"blutgruppe"] isEqualToString:@"0"]) {
                [blutgruppe selectItemAtIndex:0];
            }else if([[jsonObject objectForKey:@"blutgruppe"] isEqualToString:@"A"]) {
                [blutgruppe selectItemAtIndex:1];
            }else if([[jsonObject objectForKey:@"blutgruppe"] isEqualToString:@"B"]) {
                [blutgruppe selectItemAtIndex:2];
            }else{
                //Blutgruppe AB
                [blutgruppe selectItemAtIndex:3];
            }
        }

        if ([jsonObject objectForKey:@"allergien"]!=[NSNull null]) {
            //Allergien
            NSArray *allergienArray = [jsonObject objectForKey:@"allergien"];
            for (id object in allergienArray) {
                // do something with object
                if ([object isEqualToString:@"Blütenpollen"]) {
                    [allergie1 setState:NSOnState];
                }else if([object isEqualToString:@"Hausstaubmilben"]) {
                    [allergie2 setState:NSOnState];
                }else if([object isEqualToString:@"Nahrungsmittel"]) {
                    [allergie3 setState:NSOnState];
                }else if([object isEqualToString:@"Arzneimittel"]) {
                    [allergie4 setState:NSOnState];
                }else if([object isEqualToString:@"Tierhaare"]) {
                    [allergie5 setState:NSOnState];
                }else if([object isEqualToString:@"Nickel"]) {
                    [allergie6 setState:NSOnState];
                }else if([object isEqualToString:@"Schimmelpilz"]) {
                    [allergie7 setState:NSOnState];
                }else if([object isEqualToString:@"Latex"]) {
                    [allergie8 setState:NSOnState];
                }
            }

        }
    }else if ([jsonObject isKindOfClass:[NSArray class]]){
        // treat as an array or reassign to an array ivar.
        NSLog(@"error ist kein patient");
    }else{
        NSLog(@"Patient Neu!!!!!!!!"); 
        patientNeu=true;
    }
    
    [knView setHidden:true];
    [tabView setHidden:false];
}

- (IBAction)cancel:(id)sender{
    [self.view exitFullScreenModeWithOptions:nil];
    //[self.view removeFromSuperviewWithoutNeedingDisplay];
    [self.view removeFromSuperview];
}
- (IBAction)firstNext:(id)sender{
    [tabView selectTabViewItemAtIndex:1];
}
- (IBAction)secondBack:(id)sender{
    [tabView selectTabViewItemAtIndex:0];
}
- (IBAction)secondNext:(id)sender{
    [tabView selectTabViewItemAtIndex:2];
    
}
- (IBAction)thirdBack:(id)sender{
    [error setHidden:TRUE];
    [tabView selectTabViewItemAtIndex:1];
}
- (IBAction)writeCard:(id)sender{
    //hier magic alles schreiben
    //hole transponders
     std::vector<Transponder>  test = libnfcDevice->readTransponders();
    if (test.size()!=1) {
        //shit keine oder zuviele karten am reader
        [error setStringValue:@"Keine oder mehrere Karte am Reader!"];
        [error setHidden:FALSE];
    }else if(test[0].getType()!=DESFIRE_MIFARE){
        [error setStringValue:@"Falsche Karte am Reader!"];
        [error setHidden:FALSE];
    }else{
        //get info from user 
        NDEFMessage * message = new NDEFMessage();
        // ist immer Patient
        NDEFRecord * record1 = new TextNDEFRecord(UTF8, "de", "P");
        //hole das password
        NDEFRecord * record2 = new TextNDEFRecord(UTF8, "de", [[password stringValue]  cStringUsingEncoding: NSUTF8StringEncoding]);
        //TODO id generieren
        NDEFRecord * record3 = new TextNDEFRecord(UTF8, "de", [[krankNumber stringValue] cStringUsingEncoding: NSUTF8StringEncoding]);
        //create user "nachname,vorname"
        NSString *namestr = [name stringValue];
        namestr = [namestr stringByAppendingFormat:@", "];
        namestr = [namestr stringByAppendingFormat:[vorname stringValue]];
        NDEFRecord * record4 = new TextNDEFRecord(UTF8, "de", [namestr  cStringUsingEncoding: NSUTF8StringEncoding]);
        NDEFRecord * record5 = new TextNDEFRecord(UTF8, "de", [[telnummer stringValue] cStringUsingEncoding: NSUTF8StringEncoding]);
        //TODO alegrien 
        NSString *allegrien = @"";
        if ([allergie1 state]==NSOnState) {
            allegrien = [allegrien stringByAppendingFormat:[allergie1 title]];
            allegrien = [allegrien stringByAppendingFormat:@", "];
        }
        if ([allergie2 state]==NSOnState) {
            allegrien = [allegrien stringByAppendingFormat:[allergie2 title]];
            allegrien = [allegrien stringByAppendingFormat:@", "];
        }
        if ([allergie3 state]==NSOnState) {
            allegrien = [allegrien stringByAppendingFormat:[allergie3 title]];
            allegrien = [allegrien stringByAppendingFormat:@", "];
        }
        if ([allergie4 state]==NSOnState) {
            allegrien = [allegrien stringByAppendingFormat:[allergie4 title]];
            allegrien = [allegrien stringByAppendingFormat:@", "];
        }
        if ([allergie5 state]==NSOnState) {
            allegrien = [allegrien stringByAppendingFormat:[allergie5 title]];
            allegrien = [allegrien stringByAppendingFormat:@", "];
        }
        if ([allergie6 state]==NSOnState) {
            allegrien = [allegrien stringByAppendingFormat:[allergie6 title]];
            allegrien = [allegrien stringByAppendingFormat:@", "];
        }
        if ([allergie7 state]==NSOnState) {
            allegrien = [allegrien stringByAppendingFormat:[allergie7 title]];
            allegrien = [allegrien stringByAppendingFormat:@", "];
        }
        if ([allergie8 state]==NSOnState) {
            allegrien = [allegrien stringByAppendingFormat:[allergie8 title]];
            allegrien = [allegrien stringByAppendingFormat:@", "];
        }
        NDEFRecord * record6 = new TextNDEFRecord(UTF8, "de", [allegrien  cStringUsingEncoding: NSUTF8StringEncoding]);
        //NDEFRecord * record6 = new TextNDEFRecord(UTF8, "de", "");
        //hole blutgruppe
        NDEFRecord * record7 = new TextNDEFRecord(UTF8, "de",[[blutgruppe objectValueOfSelectedItem]  cStringUsingEncoding: NSASCIIStringEncoding]);
        //betparameter
        int bett1 = arc4random() % 50;
        int bett2 = arc4random() % 50;
        std::ostringstream out;
        out << std::hex << std::setw(2) << std::setfill('0') << static_cast<unsigned int>(static_cast<unsigned char>(bett1));
        std::string bettstring= out.str();
        std::ostringstream out1;
        bettstring.append(", ");
        out1 << std::hex << std::setw(2) << std::setfill('0') << static_cast<unsigned int>(static_cast<unsigned char>(bett2));
        bettstring.append(out1.str());
        NDEFRecord * record8 = new TextNDEFRecord(UTF8, "de",bettstring);
        
        std::string toWrite([self longToHexString:1327577247]);
        toWrite.append("108050");
        toWrite.append([self longToHexString:1327577484]);
        toWrite.append("129055");
        toWrite.append([self longToHexString:1327577684]);
        toWrite.append("087053");
        toWrite.append([self longToHexString:1327577884]);
        toWrite.append("159954");
        toWrite.append([self longToHexString:1327578084]);
        toWrite.append("177853");
        toWrite.append([self longToHexString:1327578284]);
        toWrite.append("109652");
        toWrite.append([self longToHexString:1327578484]);
        toWrite.append("139251");
        toWrite.append([self longToHexString:1327578684]);
        toWrite.append("179957");
        toWrite.append([self longToHexString:1327578884]);
        toWrite.append("158855");
        toWrite.append([self longToHexString:1327579084]);
        toWrite.append("148050");
        toWrite.append([self longToHexString:1327579284]);
        toWrite.append("129460");
        toWrite.append([self longToHexString:1327579484]);
        toWrite.append("089062");
        toWrite.append([self longToHexString:1327579684]);
        toWrite.append("259959");
        toWrite.append([self longToHexString:1327579884]);
        toWrite.append("249855");
        toWrite.append([self longToHexString:1327580084]);
        toWrite.append("308059");
        NDEFRecord * record9 = new TextNDEFRecord(UTF8, "de", "");
//        NDEFRecord * record9 = new TextNDEFRecord(UTF8, "de", "4f2e96685657564f2e966d5254534f2e96725a5c5b4f2e96775354534f2e96134e4e4e4f2e96185353524f2e961d5151504f2e96225252524f2e96274b4e4c4f2e962c4d4e4d4f2e96315456554f2e96365050504f2e963b5151504f2e96405354534f2e96455253524f2e964a5454544f2e964f5354534f2e96545556554f2e96595758574f2e965e5151504f2e9663535453");
        
       // NDEFRecord * record9 = new TextNDEFRecord(UTF8, "de", "");
        //vital daten 2 leer
        NDEFRecord * record10 = new TextNDEFRecord(UTF8, "de", "");
//        NDEFRecord * record10 = new TextNDEFRecord(UTF8, "de", "4f2e96471111104f2e964c1210104f2e96511111174f2e96561111104f2e965b1111104f2e96601111104f2e96651111104f2e966a1111104f2e966f1111104f2e96741111104f2e960b1111104f2e96101111104f2e96151111104f2e961a1111104f2e961f1111104f2e96241111104f2e96291111104f2e962e1111104f2e96381111104f2e963d1111104f2e9642123020");
        message->addNdefRecord(record1);
        message->addNdefRecord(record2);
        message->addNdefRecord(record3);
        message->addNdefRecord(record4);
        message->addNdefRecord(record5);
        message->addNdefRecord(record6);
        message->addNdefRecord(record7);
        message->addNdefRecord(record8);
        message->addNdefRecord(record9);
        message->addNdefRecord(record10);
        if (libnfcDevice->writeNDEFMessage(&test[0], message)) {
            //super hat geschrieben!!!!
            [self.view exitFullScreenModeWithOptions:nil];
            //[self.view removeFromSuperviewWithoutNeedingDisplay];
            [self.view removeFromSuperview];
        }else{
            //error beim schreiben
            
            [error setStringValue:@"Schreiben fehlgeschlagen! Bitte melden Sie sich am Schalter"];
        }
        //infos ins backendschreiben //TODO nur karte beschrieben wenn backend daten drin
        //get content string

        //nachname
        NSString* content = @"nachname=";
        content = [content stringByAppendingString:[name stringValue]];
        content = [content stringByAppendingString:@"&"];
        //vorname
        content = [content stringByAppendingString:@"vorname="];
        content = [content stringByAppendingString:[vorname stringValue]];
        //geburtstag
        content = [content stringByAppendingString:@"&geburtstag="];
        NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
        [formatter setDateFormat:@"dd.MM.yyyy"];
        content = [content stringByAppendingString:[formatter stringFromDate:[geburtstag dateValue]]];
        //notfallnummer
        content = [content stringByAppendingString:@"&notfallnummer="];
        content = [content stringByAppendingString:[telnummer stringValue]];
        //addresse
        content = [content stringByAppendingString:@"&adresse="];
        content = [content stringByAppendingString:[strasse stringValue]];
        //plz
        content = [content stringByAppendingString:@"&plz="];
        content = [content stringByAppendingString:[plz stringValue]];
        //stadt
        content = [content stringByAppendingString:@"&ort="];
        content = [content stringByAppendingString:[stadt stringValue]];
        //geschlecht
        if ([geschlecht indexOfSelectedItem]==0) {
            content = [content stringByAppendingString:@"&geschlecht=weiblich"];
        }else{
            
            content = [content stringByAppendingString:@"&geschlecht=männlich"];
        }
        //blutgruppe
        
        content = [content stringByAppendingString:@"&blutgruppe="];
        content = [content stringByAppendingString:[blutgruppe objectValueOfSelectedItem]];
        //allergien
        NSString *allegrienHTTP = @"";
        if ([allergie1 state]==NSOnState) {
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:[allergie1 title]];
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:@","];
        }
        if ([allergie2 state]==NSOnState) {
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:[allergie2 title]];
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:@","];
        }
        if ([allergie3 state]==NSOnState) {
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:[allergie3 title]];
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:@","];
        }
        if ([allergie4 state]==NSOnState) {
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:[allergie4 title]];
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:@","];
        }
        if ([allergie5 state]==NSOnState) {
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:[allergie5 title]];
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:@","];
        }
        if ([allergie6 state]==NSOnState) {
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:[allergie6 title]];
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:@","];
        }
        if ([allergie7 state]==NSOnState) {
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:[allergie7 title]];
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:@","];
        }
        if ([allergie8 state]==NSOnState) {
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:[allergie8 title]];
            allegrienHTTP = [allegrienHTTP stringByAppendingFormat:@","];
        }
        content = [content stringByAppendingString:@"&allergien="];
        content = [content stringByAppendingString:allegrienHTTP];
        content = [content stringByAppendingString:@"&befunde=2,3"];
        if(patientNeu){
                //kriere neuer Patient POST
            content = [content stringByAppendingString:@"&kknummer="];
            content = [content stringByAppendingString:[krankNumber stringValue]];
            NSLog(@"string value kkNummrer: %@", [krankNumber stringValue]);
            content = [content stringByAppendingString:@","];
            
            
            NSMutableString* requestURL = [[NSMutableString alloc] init];
            [requestURL appendString:@"http://mgt.inka.f4.htw-berlin.de:5000/personen/"];
            
            NSMutableString* requestBody = [[NSMutableString alloc] init];
            [requestBody appendString:content];
                    
            NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL: [NSURL URLWithString: [NSString stringWithString:requestURL]]];
            
            NSString* requestBodyString = [NSString stringWithString:requestBody];
            NSData *requestData = [NSData dataWithBytes: [requestBodyString UTF8String] length: [requestBodyString length]];
            
            [request setHTTPMethod: @"POST"];
            //[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"content-type"];
            [request setHTTPBody: requestData];
            
            [[NSURLConnection alloc] initWithRequest:request delegate:self];
            NSLog(@"url POST content %@",content );
            
        }else{
            //update patient infos PUT
            NSMutableString* requestURL = [[NSMutableString alloc] init];
            [requestURL appendString:@"http://mgt.inka.f4.htw-berlin.de:5000/personen/"];
            [requestURL appendString:[krankNumber stringValue]];
            [requestURL appendString:@"/"];
            NSLog(@"url PUT %@",requestURL );
            NSMutableString* requestBody = [[NSMutableString alloc] init];
            [requestBody appendString:content];
            
            NSMutableURLRequest *request = [[NSMutableURLRequest alloc] initWithURL: [NSURL URLWithString: [NSString stringWithString:requestURL]]];
            
            NSString* requestBodyString = [NSString stringWithString:requestBody];
            NSData *requestData = [NSData dataWithBytes: [requestBodyString UTF8String] length: [requestBodyString length]];
            [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
            [request setHTTPMethod: @"PUT"];
            //[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"content-type"];
            [request setHTTPBody: requestData];
            
//            NSData* respData = [NSURLConnection sendSynchronousRequest:request
//                                             returningResponse:&response
//                                                         error:&error];
            [[NSURLConnection alloc] initWithRequest:request delegate:self];
            NSLog(@"url PUT content %@",content );
        }
    }
  //  [self.view s
}

-(std::string) longToHexString:(long) ts{
    std::stringstream Buffer;
    Buffer <<std::hex<< ts;
    return Buffer.str();
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
    //
}

// Called when data has been received
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    NSString *postAntwort = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    NSLog(@"haha: %@",postAntwort);
   // [httpResponse appendData:data];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    //NSString* responseString = [[[NSString alloc] initWithData:httpResponse encoding:NSUTF8StringEncoding] copy];
    
    // Do something with the response
    
    [connection release];
    //[httpResponse release];
}

@end
