//
//  ReadCardViewController.h
//  NFCKrankehausAnmeldung
//
//  Created by Maurus Rohrer on 1/17/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "NDEFRecord.h"
#import <vector>

@interface ReadCardViewController : NSViewController {
    IBOutlet NSButton *detaillsButton;
    bool detailsShow;
    std::vector<NDEFRecord*> records;
    
    IBOutlet NSButton *passwordButton;
    
    IBOutlet NSTextField * vorname;
    IBOutlet NSTextField * nachname;
    IBOutlet NSTextField * blutgruppe;
    IBOutlet NSTextField * allergien;
    IBOutlet NSTextField * password;
    IBOutlet NSTextField * fehler;
    
    IBOutlet NSTextField * telnummer;
    IBOutlet NSView* passwordView;
    IBOutlet NSView* detailView;
}
- (IBAction)cancel:(id)sender;
- (void)setRecordValues:(std::vector<NDEFRecord*>)records;

- (IBAction) showDetails:(id)sender;
-(IBAction)checkPassword:(id)sender;

@property (nonatomic, retain) IBOutlet NSView* passwordView;
@property (nonatomic, retain) IBOutlet NSView* detailView;
@property (assign) IBOutlet NSTextField *vorname;
@property (assign) IBOutlet NSTextField *nachname;
@property (assign) IBOutlet NSTextField * blutgruppe;
@property (assign) IBOutlet NSTextField * allergien;
@property (assign) IBOutlet NSTextField * password;
@property (assign) IBOutlet NSTextField * fehler;
@property (assign) IBOutlet NSButton *detaillsButton;
@property (assign) IBOutlet NSButton *passwordButton;
@property (assign) IBOutlet NSTextField * telnummer;
@end

