//
//  ReadCardViewController.m
//  NFCKrankehausAnmeldung
//
//  Created by Maurus Rohrer on 1/17/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "ReadCardViewController.h"


@implementation ReadCardViewController
@synthesize vorname,nachname,passwordView, blutgruppe, allergien, detaillsButton, passwordButton, detailView, password, fehler,telnummer;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Initialization code here.
    }
    detailsShow=false;
    return self;
}



- (void)setRecordValues:(std::vector<NDEFRecord*>)record{
    records = record;
    NSString *name = [NSString stringWithCString:record[3]->getPayload().c_str() encoding:NSUTF8StringEncoding];
    NSLog(@"name: %@", name);
    NSArray *lines = [name componentsSeparatedByString:@", "];
    [nachname setStringValue:[lines objectAtIndex:0]];
    [vorname setStringValue:[lines objectAtIndex:1]];
    
    NSLog(@"nachname: %@", [lines objectAtIndex:0]);
    NSLog(@"vorname: %@", [lines objectAtIndex:1]);
    
    NSString *tel = [NSString stringWithCString:record[4]->getPayload().c_str() encoding:NSASCIIStringEncoding];
    [telnummer setStringValue:tel];
    
    NSString *blut = [NSString stringWithCString:record[6]->getPayload().c_str() encoding:NSASCIIStringEncoding];
        [blutgruppe setStringValue:blut];
    
    //get allergien
     NSString *allergie = [NSString stringWithCString:record[5]->getPayload().c_str() encoding:NSASCIIStringEncoding];
    NSArray *allergienArray = [allergie componentsSeparatedByString:@", "];
    if ([allergienArray count]>0) {
        //to do
        NSString *allerg=@"";
        for (int i=0; i<[allergienArray count]-1; i++) {
            allerg = [allerg stringByAppendingFormat:@"- "];
            allerg = [allerg stringByAppendingFormat:[allergienArray objectAtIndex:i]];
            allerg = [allerg stringByAppendingFormat:@"\n"];
        }
        [allergien setStringValue:allerg];
    }
}

- (void)dealloc
{
    [super dealloc];
}
- (IBAction)cancel:(id)sender{
    [self.view exitFullScreenModeWithOptions:nil];
    //[self.view removeFromSuperviewWithoutNeedingDisplay];
    [self.view removeFromSuperview];
}


- (IBAction) showDetails:(id)sender{
    if (detailsShow) {
        detailsShow=false;
        [passwordView setHidden:TRUE];
        [detailView setHidden:TRUE];
        [detaillsButton setTitle:@"Detaillierte Informationen"];
        [fehler setHidden:TRUE];
        [password setStringValue:@""];
    }else{
        detailsShow=true;
        NSLog(@"test hidden");
        [passwordView setHidden:FALSE];
        [detaillsButton setTitle:@"Informationen ausblenden"];
    }
    


}

-(IBAction)checkPassword:(id)sender{
    NSLog(@"password eigenengeb %@", [password stringValue]);
    NSLog(@"password auf karte %@", [NSString stringWithCString:records[1]->getPayload().c_str() encoding:NSASCIIStringEncoding]);
    if ([[password stringValue] isEqualToString:[NSString stringWithCString:records[1]->getPayload().c_str() encoding:NSASCIIStringEncoding]]) {
        [fehler setHidden:TRUE];
        [passwordView setHidden:TRUE];
        [detailView setHidden:FALSE];
    }else{
        [fehler setStringValue:@"Password ist falsch!"];
        [fehler setHidden:FALSE];
    }
    
}
@end
