//Copyright 2011 INKA - HTW Berlin
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
//  Created by Maurus Rohrer maurus.rohrer@gmail.com
//

#ifndef Scl3711DeviceManager_
#define Scl3711DeviceManager_

#include "LibnfcDeviceManager.h"

class Scl3711DeviceManager : public LibnfcDeviceManager
{
    
public:
    bool connect();
    bool disconnect();
    void readTransponders(std::vector<Transponder>*);
    bool isNDEFConform(Transponder*);
    bool makeNDEFConform(Transponder*);
    bool writeNDEFMessage(Transponder*,NDEFMessage*);
};

#endif