//Copyright 2011 INKA - HTW Berlin
//
//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
//  Created by Maurus Rohrer maurus.rohrer@gmail.com


#include "Transponder.h"


Transponder::Transponder(std::string id): ID(id){
    type = UNKNOWN;
}


std::string Transponder::getID(){
    return ID;
}

int Transponder::getSize(){
    return size;
}

void Transponder::setSize(int si){
    size = si; 
}

TransponderType Transponder::getType(){
    return type;
}


std::ostream& operator<<(std::ostream& output, const Transponder& t) {
    output << t.ID;
    return output;  // for multiple << operators.
}
