package de.htwberlin.magw.model;


public class ArztInfo {

	private static ArztInfo _instance;
	private String userId;
	private String name;
	private String lastname;
	private String password;

	private ArztInfo() {
		
	}
	
	public static ArztInfo getInstance() {
		if (_instance == null) {
			_instance = new ArztInfo();
		}
		return _instance;
	}

	public static ArztInfo getInstance(String userId) {
		if (_instance == null) {
			_instance = new ArztInfo();
		}
		if (userId != null) {
			_instance.setUserId(userId);
		}
		return _instance;
	}
	
	public void reset() {
		this.userId = null;
		this.name = null;
		this.lastname = null;
		this.password = null;
	}
	
	public void setUserId(String userId) {
		this.userId = userId;
	}
	
	public String getUserId() {
		return this.userId;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getLastname() {
		return lastname;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}
}
