package de.htwberlin.magw.model;

public class DiagnosticReport {

	private static final String LOGTAG = "DiagnosticReport";
	
	private String id;
	private String person;
	private String title;
	private String text;
	private String imageUrl;
	private String date;
	
	public DiagnosticReport(String id, String person, String title, String text, String imgUrl, String date) {
		this.id = id;
		this.person = person;
		this.title = title;
		this.text = text;
		this.imageUrl = imgUrl;
		this.date = date;
	}

	public String getId() {
		return id;
	}

	public String getPerson() {
		return person;
	}

	public String getTitle() {
		return title;
	}

	public String getText() {
		return text;
	}

	public String getImageUrl() {
		return imageUrl;
	}

	public String getDate() {
		return date;
	}
}
