package de.htwberlin.magw.model;

import java.util.Date;

public class VitalDataSet implements Comparable<VitalDataSet>{

	
	private Date date;
	private int maxValue;
	private int minValue;
	private int avrValue;

	public VitalDataSet(String vitalString){
		String val = new String("0x");
		val+=vitalString.substring(0,8);
		date = new Date(1000*Long.decode(val));
		this.minValue=Integer.parseInt(vitalString.substring(8,10),16);
		this.maxValue=Integer.parseInt(vitalString.substring(10,12),16);
		this.avrValue=Integer.parseInt(vitalString.substring(12,14),16);
		
	}
	public Date getDate() {
		return date;
	}
	public void setDate(Date date) {
		this.date = date;
	}
	public int getMaxValue() {
		return maxValue;
	}
	public void setMaxValue(int maxValue) {
		this.maxValue = maxValue;
	}
	public int getMinValue() {
		return minValue;
	}
	public void setMinValue(int minValue) {
		this.minValue = minValue;
	}
	public int getAvrValue() {
		return avrValue;
	}
	public void setAvrValue(int avrValue) {
		this.avrValue = avrValue;
	}
	
	public int compareTo( VitalDataSet aThat ) {
	return this.date.compareTo(aThat.getDate());
	}

}
