/*
 * TODO: <Classname> - <Description> 
 *
 * Copyright (c) 2011 Stephan Bergemann oberling@deroberling.de
 *
 * This file is part of TODO: <Projectname>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program (see COPYING); if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#ifndef MEASURINGINSTRUMENT_H
#define MEASURINGINSTRUMENT_H

#include <QObject>
#include <QList>
#include <QMap>

class MeasuringInstrument : public QObject
{
    Q_OBJECT
public:
    explicit MeasuringInstrument(QObject *parent = 0);
    ~MeasuringInstrument();

    QMap<QString, quint8> getValues();
    void setEnabled(bool _enabled);
    void disable();
    void enable();
signals:

public slots:
protected:
    void addMeasurement(quint8 m);
private:
    QList<quint8>* _values;
    bool _enabled;
};

#endif // MEASURINGINSTRUMENT_H
