//
//  AnmeldungViewController.h
//  NFCKrankehausAnmeldung
//
//  Created by Maurus Rohrer on 1/18/12.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "LibnfcDeviceManager.h"


@interface AnmeldungViewController : NSViewController {
        IBOutlet NSTextField * name;
        IBOutlet NSTextField * vorname;
        IBOutlet NSTextField * strasse;
        IBOutlet NSTextField * stadt;
        IBOutlet NSDatePicker * geburtstag;
        IBOutlet NSTextField * telnummer;
        IBOutlet NSTextField * plz;
        IBOutlet NSComboBox * geschlecht;
        IBOutlet NSComboBox * blutgruppe;
        IBOutlet NSTextField *password;
        IBOutlet NSTextField *error;
    
    IBOutlet NSButton *allergie1;
    IBOutlet NSButton *allergie2;
    IBOutlet NSButton *allergie3;
    IBOutlet NSButton *allergie4;
    IBOutlet NSButton *allergie5;
    IBOutlet NSButton *allergie6;
    IBOutlet NSButton *allergie7;
    IBOutlet NSButton *allergie8;
        
        IBOutlet NSView *knView;
        IBOutlet NSTextField *krankNumber;
        IBOutlet NSTabView *tabView;
    
    Boolean patientNeu;
    
    LibnfcDeviceManager *libnfcDevice;
}
- (IBAction)cancel:(id)sender;
- (IBAction)firstNext:(id)sender;
- (IBAction)secondBack:(id)sender;
- (IBAction)secondNext:(id)sender;
- (IBAction)thirdBack:(id)sender;
- (IBAction)writeCard:(id)sender;
- (IBAction)loadPatienInfo:(id)sender;

-(void)initAfterload:(LibnfcDeviceManager*)device;
-(std::string) longToHexString:(long)ts;

@property (assign) IBOutlet NSTextField * name;
@property (assign) IBOutlet NSTextField * vorname;
@property (assign) IBOutlet NSTextField * strasse;
@property (assign) IBOutlet NSTextField * stadt;
@property (assign) IBOutlet NSDatePicker * geburtstag;
@property (assign) IBOutlet NSTextField * telnummer;
@property (assign) IBOutlet NSTextField * plz;
@property (assign) IBOutlet NSComboBox * geschlecht;
@property (assign) IBOutlet NSTabView *tabView;
@property (assign) IBOutlet NSComboBox * blutgruppe;
@property (assign) IBOutlet NSTextField *password;
@property (assign) NSView *knView;
@property (assign) NSTextField *krankNumber;
@property (assign) IBOutlet NSButton *allergie1;
@property (assign) IBOutlet NSButton *allergie2;
@property (assign) IBOutlet NSButton *allergie3;
@property (assign) IBOutlet NSButton *allergie4;
@property (assign) IBOutlet NSButton *allergie5;
@property (assign) IBOutlet NSButton *allergie6;
@property (assign) IBOutlet NSButton *allergie7;
@property (assign) IBOutlet NSButton *allergie8;
@property (assign) IBOutlet NSTextField *error;
@end
